
local WaterMill = ...

-- Register core prefab nodes (currently only one core model)
WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CoreFlourPart", "WATER_MILL_CORE_FLOUR_PREFAB")
WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CoreTextilePart", "WATER_MILL_CORE_TEXTILE_PREFAB")
WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart", "WATER_MILL_CORE_PLANKS_PREFAB")

-- Register extension wheel prefab nodes
WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/ExtensionLeftBankPart", "WATER_MILL_EXTENSION_LEFT_BANK_PREFAB")
WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/ExtensionRightBankPart", "WATER_MILL_EXTENSION_RIGHT_BANK_PREFAB")

-- Register decoration prefab nodes
--WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/Decoration/DoorPart", "WATER_MILL_DECORATION_DOOR_PREFAB")
--WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/Decoration/WindowPart", "WATER_MILL_DECORATION_WINDOW_PREFAB")

-- Register the water mill Core Flour part
WaterMill:register({
	DataType = "BUILDING_PART",
	Id = "WATER_MILL_CORE_FLOUR_PART",
	Name = "WATER_MILL_CORE_FLOUR_NAME",
	Description = "WATER_MILL_CORE_FLOUR_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "WATER_MILL_CORE_FLOUR_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 2,
                RelatedJob = { Job = "MILLER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "WHEAT", Quantity = 10 }
                },
                ResourceListNeeded = {
			{ Resource = "WHEAT", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "FLOUR", Quantity = 1 }
                }
	}
})

-- Register the water mill Core Textile part
WaterMill:register({
	DataType = "BUILDING_PART",
	Id = "WATER_MILL_CORE_TEXTILE_PART",
	Name = "WATER_MILL_CORE_TEXTILE_NAME",
	Description = "WATER_MILL_CORE_TEXTILE_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "WATER_MILL_CORE_TEXTILE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 2,
                RelatedJob = { Job = "WEAVER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "WOOL", Quantity = 10 }
                },
                ResourceListNeeded = {
			{ Resource = "WOOL", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
                }
	}
})

-- Register the water mill Core Planks part
WaterMill:register({
	DataType = "BUILDING_PART",
	Id = "WATER_MILL_CORE_PLANKS_PART",
	Name = "WATER_MILL_CORE_PLANKS_NAME",
	Description = "WATER_MILL_CORE_PLANKS_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "WATER_MILL_CORE_PLANKS_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 3,
                RelatedJob = { Job = "CARPENTER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "WOOD", Quantity = 10 }
                },
                ResourceListNeeded = {
			{ Resource = "WOOD", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "PLANK", Quantity = 1 }
                }
	}
})

-- Register the water mill Extension Wheel Right Bank part
WaterMill:register({
	DataType = "BUILDING_PART",
	Id = "WATER_MILL_EXTENSION_RIGHT_BANK_PART",
	Name = "WATER_MILL_EXTENSION_RIGHT_BANK_NAME",
	Description = "WATER_MILL_EXTENSION_RIGHT_BANK_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "WATER_MILL_EXTENSION_RIGHT_BANK_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	}
})

-- Register the water mill Extension Wheel Left Bank part
WaterMill:register({
	DataType = "BUILDING_PART",
	Id = "WATER_MILL_EXTENSION_LEFT_BANK_PART",
	Name = "WATER_MILL_EXTENSION_LEFT_BANK_NAME",
	Description = "WATER_MILL_EXTENSION_LEFT_BANK_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "WATER_MILL_EXTENSION_LEFT_BANK_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	}
})

WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CoreFlourPart/step_0/SmokeEmitter", "WATER_MILL_CORE_FLOUR_SMOKE_EMITTER_PREFAB")

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreFlourPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{ "WATER_MILL_CORE_FLOUR_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CoreTextilePart/step_0/SmokeEmitter", "WATER_MILL_CORE_TEXTILE_SMOKE_EMITTER_PREFAB")

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreTextilePart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{ "WATER_MILL_CORE_TEXTILE_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SmokeEmitter", "WATER_MILL_CORE_PLANKS_SMOKE_EMITTER_PREFAB")

WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SawSmokeEmitter", "WATER_MILL_CORE_PLANKS_SAW_SMOKE_EMITTER_PREFAB")

WaterMill:registerAssetId("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SawSparkEmitter", "WATER_MILL_CORE_PLANKS_SAW_SPARK_EMITTER_PREFAB")

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{ "WATER_MILL_CORE_PLANKS_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" },
		{ "WATER_MILL_CORE_PLANKS_SAW_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" },
		{ "WATER_MILL_CORE_PLANKS_SAW_SPARK_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

--WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart", {
--	DataType = "COMP_BUILDING_PART",
--	FeedbackComponentListToActivate = {
--		{ "WATER_MILL_CORE_PLANKS_SAW_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
--	}
--})


--WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart", {
--	DataType = "COMP_BUILDING_PART",
--	FeedbackComponentListToActivate = {
--		{ "WATER_MILL_CORE_PLANKS_SAW_SPARK_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
--	}
--})

-- Register particle system

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreFlourPart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreFlourPart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreTextilePart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreTextilePart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SawSmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_SAWMILL_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SawSmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})


WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SawSparkEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_SAWMILL_SPARK",
	IsPlaying = true,
	IsEmitting = false
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart/step_0/SawSparkEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

-- Register the water mill decoration door part
--WaterMill:register({
--	DataType = "BUILDING_PART",
--	Id = "WATER_MILL_DECORATION_DOOR_PART",
--	Name = "WATER_MILL_DECORATION_DOOR_NAME",
--	Description = "WATER_MILL_DECORATION_DOOR_DESC",
--	Category = "DOOR",
--	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
--	ConstructorData = {
--		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
--		CoreObjectPrefab = "WATER_MILL_DECORATION_DOOR_PREFAB"
--	},
--	Cost = {
--		UpkeepCost = {
--			{ Resource = "GOLD", Quantity = 0 }
--		},
--		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
--			{ Resource = "WOOD", Quantity = 1 }
--		}
--	}
--})

-- Register grounding components
--WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/Decoration/DoorPart", {
--	DataType = "COMP_GROUNDED"
--})

-- Register grass clearing components

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreFlourPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {8, 4}
})
WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreTextilePart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {8, 4}
})
WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {8, 4}
})

-- Override building part components properties (generated by the building asset processor) to add building zones
WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreFlourPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 8, 4 }
})
WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CoreTextilePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 8, 4 }
})
WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/CorePlanksPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 8, 4 }
})

WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/ExtensionRightBankPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 6, 4 }
})
WaterMill:registerPrefabComponent("models/waterMill.fbx/Prefab/waterMill/ExtensionLeftBankPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 6, 4 }
})
